SystemOrganization addCategory: #TypeFeedback!

!ObjectMemory class methodsFor: '*typefeedback-override' stamp: 'mha 8/2/2007 18:00'!
initializeSpecialObjectIndices
	"Initialize indices into specialObjects array."

	NilObject := 0.
	FalseObject := 1.
	TrueObject := 2.
	SchedulerAssociation := 3.
	ClassBitmap := 4.
	ClassInteger := 5.
	ClassString := 6.
	ClassArray := 7.
	"SmalltalkDictionary := 8."  "Do not delete!!"
	ClassFloat := 9.
	ClassMethodContext := 10.
	ClassBlockContext := 11.
	ClassPoint := 12.
	ClassLargePositiveInteger := 13.
	TheDisplay := 14.
	ClassMessage := 15.
	ClassCompiledMethod := 16.
	TheLowSpaceSemaphore := 17.
	ClassSemaphore := 18.
	ClassCharacter := 19.
	SelectorDoesNotUnderstand := 20.
	SelectorCannotReturn := 21.
	ProcessSignalingLowSpace := 22.	"was TheInputSemaphore"
	SpecialSelectors := 23.
	CharacterTable := 24.
	SelectorMustBeBoolean := 25.
	ClassByteArray := 26.
	ClassProcess := 27.
	CompactClasses := 28.
	TheTimerSemaphore := 29.
	TheInterruptSemaphore := 30.
	SelectorCannotInterpret := 34.
	MethodContextProto := 35.
	BlockContextProto := 37.
	ExternalObjectsArray := 38.
	ClassPseudoContext := 39.
	ClassTranslatedMethod := 40.
	TheFinalizationSemaphore := 41.
	ClassLargeNegativeInteger := 42.

	ClassExternalAddress := 43.
	ClassExternalStructure := 44.
	ClassExternalData := 45.
	ClassExternalFunction := 46.
	ClassExternalLibrary := 47.

	SelectorAboutToReturn := 48.
	SelectorRunWithIn := 49.

	MonomorphicCache := 50.
	PolymorphicCache := 51.! !

!Object methodsFor: '*typefeedback' stamp: 'mha 7/4/2007 01:26'!
isCache
	^ false! !

!Object methodsFor: '*typefeedback' stamp: 'mha 7/4/2007 01:18'!
isMonomorphicCache
	^ false! !

!Object methodsFor: '*typefeedback' stamp: 'mha 7/4/2007 01:18'!
isPolymorphicCache
	^ false! !

!SystemDictionary methodsFor: '*typefeedback-override' stamp: 'mha 8/10/2007 23:28'!
recreateSpecialObjectsArray
	"Smalltalk recreateSpecialObjectsArray"
	"The Special Objects Array is an array of object pointers used
	by the
	Squeak virtual machine. Its contents are critical and
	unchecked, so don't even think of playing here unless you
	know what you are doing."
	| newArray |
	newArray := Array new: 52.
	"Nil false and true get used throughout the interpreter"
	newArray at: 1 put: nil.
	newArray at: 2 put: false.
	newArray at: 3 put: true.
	"This association holds the active process (a ProcessScheduler)"
	newArray
		at: 4
		put: (self associationAt: #Processor).
	"Numerous classes below used for type checking and
	instantiation"
	newArray at: 5 put: Bitmap.
	newArray at: 6 put: SmallInteger.
	newArray at: 7 put: ByteString.
	newArray at: 8 put: Array.
	newArray at: 9 put: Smalltalk.
	newArray at: 10 put: Float.
	newArray at: 11 put: MethodContext.
	newArray at: 12 put: BlockContext.
	newArray at: 13 put: Point.
	newArray at: 14 put: LargePositiveInteger.
	newArray at: 15 put: Display.
	newArray at: 16 put: Message.
	newArray at: 17 put: CompiledMethod.
	newArray
		at: 18
		put: (self specialObjectsArray at: 18).
	"(low space Semaphore)"
	newArray at: 19 put: Semaphore.
	newArray at: 20 put: Character.
	newArray at: 21 put: #doesNotUnderstand:.
	newArray at: 22 put: #cannotReturn:.
	"The process that signaled the low space semaphore."
	newArray at: 23 put: nil.
	"An array of the 32 selectors that are compiled as special
	bytecodes, paired alternately with the number of arguments
	each takes."
	newArray at: 24 put: #(#+ 1 #- 1 #< 1 #> 1 #<= 1 #>= 1 #= 1 #~= 1 #* 1 #/ 1 #\\ 1 #@ 1 #bitShift: 1 #// 1 #bitAnd: 1 #bitOr: 1 #at: 1 #at:put: 2 #size 0 #next 0 #nextPut: 1 #atEnd 0 #== 1 #class 0 #blockCopy: 1 #value 0 #value: 1 #do: 1 #new 0 #new: 1 #x 0 #y 0 ).
	"An array of the 255 Characters in ascii order."
	newArray
		at: 25
		put: ((0 to: 255)
				collect: [:ascii | Character value: ascii]).
	newArray at: 26 put: #mustBeBoolean.
	newArray at: 27 put: ByteArray.
	newArray at: 28 put: Process.
	"An array of up to 31 classes whose instances will have
	compact headers"
	newArray at: 29 put: self compactClassesArray.
	newArray
		at: 30
		put: (self specialObjectsArray at: 30).
	"(delay Semaphore)"
	newArray
		at: 31
		put: (self specialObjectsArray at: 31).
	"(user interrupt Semaphore)"
	"Prototype instances that can be copied for fast initialization"
	newArray
		at: 32
		put: (Float new: 2).
	newArray
		at: 33
		put: (LargePositiveInteger new: 4).
	newArray at: 34 put: Point new.
	newArray at: 35 put: #cannotInterpret:.
	"Note: This must be fixed once we start using context
	prototypes"
	newArray
		at: 36
		put: (self specialObjectsArray at: 36).
	"(MethodContext new: CompiledMethod fullFrameSize)."
	newArray at: 37 put: nil.
	newArray
		at: 38
		put: (self specialObjectsArray at: 38).
	"(BlockContext new: CompiledMethod fullFrameSize)."
	newArray at: 39 put: Array new.
	"array of objects referred to by external code"
	newArray at: 40 put: PseudoContext.
	newArray at: 41 put: TranslatedMethod.
	"finalization Semaphore"
	newArray
		at: 42
		put: ((self specialObjectsArray at: 42)
				ifNil: [Semaphore new]).
	newArray at: 43 put: LargeNegativeInteger.
	"External objects for callout.
	Note: Written so that one can actually completely remove the
	FFI."
	newArray
		at: 44
		put: (self
				at: #ExternalAddress
				ifAbsent: []).
	newArray
		at: 45
		put: (self
				at: #ExternalStructure
				ifAbsent: []).
	newArray
		at: 46
		put: (self
				at: #ExternalData
				ifAbsent: []).
	newArray
		at: 47
		put: (self
				at: #ExternalFunction
				ifAbsent: []).
	newArray
		at: 48
		put: (self
				at: #ExternalLibrary
				ifAbsent: []).
	newArray at: 49 put: #aboutToReturn:through:.
	newArray at: 50 put: #run:with:in:.
	
	"type feedback cache classes"
	newArray at: 51 put: TFMonomorphicCache.
	newArray at: 52 put: TFPolymorphicCache.
	
	"Now replace the interpreter's reference in one atomic
	operation"
	self specialObjectsArray become: newArray! !

!Interpreter methodsFor: '*typefeedback-override' stamp: 'mha 7/4/2007 01:45'!
doubleExtendedDoAnythingBytecode
	"Replaces the Blue Book double-extended send [132], in which the first byte was wasted on 8 bits of argument count. 
	Here we use 3 bits for the operation sub-type (opType),  and the remaining 5 bits for argument count where needed. 
	The last byte give access to 256 instVars or literals. 
	See also secondExtendedSendBytecode"
	| byte2 byte3 opType top |
	byte2 := self fetchByte.
	byte3 := self fetchByte.
	opType := byte2 >> 5.
	opType = 0 ifTrue: [messageSelector := self extractSelectorAndInstallCacheForLiteral: byte3.
			argumentCount := byte2 bitAnd: 31.
			^ self normalSend].
	opType = 1 ifTrue: [messageSelector := self extractSelectorAndInstallCacheForLiteral: byte3.
			argumentCount := byte2 bitAnd: 31.
			^ self superclassSend].
	self fetchNextBytecode.
	opType = 2 ifTrue: [^ self pushReceiverVariable: byte3].
	opType = 3 ifTrue: [^ self pushLiteralConstant: byte3].
	opType = 4 ifTrue: [^ self pushLiteralVariable: byte3].
	opType = 5 ifTrue: [top := self internalStackTop.
			^ self storePointer: byte3 ofObject: receiver withValue: top].
	opType = 6
		ifTrue: [top := self internalStackTop.
			self internalPop: 1.
			^ self storePointer: byte3 ofObject: receiver withValue: top].
	opType = 7
		ifTrue: [top := self internalStackTop.
			^ self storePointer: ValueIndex ofObject: (self literal: byte3) withValue: top]! !

!Interpreter methodsFor: '*typefeedback' stamp: 'mha 8/2/2007 17:51'!
extractSelectorAndInstallCacheForLiteral: index
	"Extract the selector from the literal slot at the given index. In case the slot contains a plain selector, the interpreter's messageSelector is set to that value. In case the slot contains a monomorphic/polymorphic cache, the selector is extracted from the cache. If the slot does not yet contain a cache, a monomorphic one is installed immediately and populated with the selector in question."
	
	messageSelector := self literal: index. "Storing whichever result in messageSelector saves a local variable."
	
	messageSelector isCache
		ifTrue: [ messageSelector := messageSelector at: 1 "first entry in cache is always the selector" ]
		ifFalse: [ "messageSelector is an actual selector"
			self
				storePointer: index + LiteralStart
				ofObject: method
				withValue: (TFMonomorphicCache forSelector: messageSelector) ]! !

!Interpreter methodsFor: '*typefeedback-override' stamp: 'mha 6/22/2007 19:48'!
internalFindNewMethod
	"Find the compiled method to be run when the current messageSelector is sent to the class 'lkupClass', setting the values of 'newMethod' and 'primitiveIndex'."
	| ok | 
	self inline: true.
	
	"----- Type feedback activities (proposal). -----"
	
	"Here's what happens:
		1. Is there a cache for this send?
			1a. No -> Create a monomorphic one, then proceed with 2b1.
		2. Cache hit in first entry? (Compare, regardless of whether this is a monomorphic or polymorphic cache, the cache array entry at index 3 and lkupClass.)
			2a. Yes -> Increase hotness counter (regardless of cache entry, this is index 4), then bail out.
			2b. No -> Cache type?
				2b1. Monomorphic -> Increase trip counter and retrieve result as usual, then bail out after inserting result in cache.
				2b2. Polymorphic -> Iterate over cache entries; once found, increase hotness counter and bail out; if nothing is found, retrieve result the usual way and add it to cache (we still need a policy for dealing with a full polymorphic cache)."
	
	"----- End of type feedback activities. -----"
	
	ok := self lookupInMethodCacheSel: messageSelector class: lkupClass.
	ok ifFalse: [
		"entry was not found in the cache; look it up the hard way"
		self externalizeIPandSP.
		self lookupMethodInClass: lkupClass.
		self internalizeIPandSP.
		self addNewMethodToCache].
! !

!Interpreter methodsFor: '*typefeedback-override' stamp: 'mha 7/4/2007 01:44'!
secondExtendedSendBytecode
	"This replaces the Blue Book double-extended super-send [134],
	which is subsumed by the new double-extended do-anything [132].
	It offers a 2-byte send of 0-3 args for up to 63 literals, for which 
	the Blue Book opcode set requires a 3-byte instruction."

	| descriptor |
	descriptor := self fetchByte.
	messageSelector := self extractSelectorAndInstallCacheForLiteral: (descriptor bitAnd: 16r3F).
	argumentCount := descriptor >> 6.
	self normalSend.
! !

!Interpreter methodsFor: '*typefeedback-override' stamp: 'mha 7/4/2007 01:43'!
sendLiteralSelectorBytecode
	"Can use any of the first 16 literals for the selector and pass up to 2 arguments."

	messageSelector := self extractSelectorAndInstallCacheForLiteral: (currentBytecode bitAnd: 16rF).
	argumentCount := ((currentBytecode >> 4) bitAnd: 3) - 1.
	self normalSend! !

!Interpreter methodsFor: '*typefeedback-override' stamp: 'mha 7/4/2007 01:43'!
singleExtendedSendBytecode
	"Can use any of the first 32 literals for the selector and pass up to 7 arguments."

	| descriptor |
	descriptor := self fetchByte.
	messageSelector := self extractSelectorAndInstallCacheForLiteral: (descriptor bitAnd: 16r1F).
	argumentCount := descriptor >> 5.
	self normalSend.! !

!Interpreter methodsFor: '*typefeedback-override' stamp: 'mha 7/4/2007 01:44'!
singleExtendedSuperBytecode
	"Can use any of the first 32 literals for the selector and pass up to 7 arguments."

	| descriptor |
	descriptor := self fetchByte.
	messageSelector := self extractSelectorAndInstallCacheForLiteral: (descriptor bitAnd: 16r1F).
	argumentCount := descriptor >> 5.
	self superclassSend.
! !

Array variableSubclass: #TFMonomorphicCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TypeFeedback'!

!TFMonomorphicCache commentStamp: 'mha 6/22/2007 19:41' prior: 0!
An instance of this class represents an "inline cache" object, i.e., an object that caches, for a given send site, the most recently resolved concrete method implementation. The class is a subclass of Array. Its instances are 5 slots long:

	1:	selector			-	the selector sent at this send site (Symbol)
	2:	targetMethod	-	the most recently resolved concrete method implementation (CompiledMethod)
	3:	targetClass		-	the most recently resolved concrete target class (Class)
	4:	hotness			-	the hotness counter for this send (SmallInteger)
	5:	trips			-	the trip counter for this cache (SmallInteger)

The hotness counter is incremented each time the send is executed. The trip counter is incremented each time the cached class and method are replaced with new values because the cache has produced a miss.!

!TFMonomorphicCache class methodsFor: 'instance creation' stamp: 'mha 6/18/2007 21:00'!
defaultSize
	"Return the size of a TFSingleEntryCache object. It contains 5 entries as specified in the class comment."
	
	^ 5! !

!TFMonomorphicCache class methodsFor: 'instance creation' stamp: 'mha 7/4/2007 01:37'!
forSelector: aSelector
	"Create an instance of the cache for a given selector. Set the most recently resolved class and method to nil."
	
	^ self forSelector: aSelector resolvedClass: nil resolvedMethod: nil! !

!TFMonomorphicCache class methodsFor: 'instance creation' stamp: 'mha 6/22/2007 19:42'!
forSelector: aSelector resolvedClass: aClass resolvedMethod: aCompiledMethod
	"Create an instance of the cache for a given selector and most recently resolved class and method. Set hotness and trip counters to zero."
	
	^ (self new: self defaultSize)
		at: 1 put: aSelector;
		at: 2 put: aCompiledMethod;
		at: 3 put: aClass;
		at: 4 put: 0;		"hotness counter"
		at: 5 put: 0		"trip counter";
		yourself! !

!TFMonomorphicCache class methodsFor: 'resetting' stamp: 'mha 6/21/2007 21:17'!
resetHotnessCounters
	"Reset all hotness counters in monomorphic caches to zero."
	
	self allInstancesDo: [ :mc | mc resetHotnessCounter ]! !

!TFMonomorphicCache class methodsFor: 'resetting' stamp: 'mha 6/21/2007 21:17'!
resetTripCounters
	"Reset all trip counters in monomorphic caches to zero."
	
	self allInstancesDo: [ :mc | mc resetTripCounter ]! !

!TFMonomorphicCache methodsFor: 'accessing' stamp: 'mha 6/21/2007 21:41'!
hotness
	"Answer this monomorphic cache's current hotness counter value."
	
	^ self at: 4! !

!TFMonomorphicCache methodsFor: 'testing' stamp: 'mha 7/4/2007 01:26'!
isCache
	^ true! !

!TFMonomorphicCache methodsFor: 'testing' stamp: 'mha 7/4/2007 01:19'!
isMonomorphicCache
	^ true! !

!TFMonomorphicCache methodsFor: 'resetting' stamp: 'mha 6/21/2007 21:18'!
resetHotnessCounter
	"Reset this cache's hotness counter to zero."
	
	self at: 4 put: 0! !

!TFMonomorphicCache methodsFor: 'resetting' stamp: 'mha 6/21/2007 21:18'!
resetTripCounter
	"Reset this cache's trip counter to zero."
	
	self at: 5 put: 0! !

!TFMonomorphicCache methodsFor: 'accessing' stamp: 'mha 6/21/2007 21:42'!
selector
	"Answer the selector at this cache's send site."
	
	^ self at: 1! !

!TFMonomorphicCache methodsFor: 'accessing' stamp: 'mha 6/22/2007 19:42'!
targetClass
	"Answer the currently cached target class, i.e., the most recently looked-up one."
	
	^ self at: 3! !

!TFMonomorphicCache methodsFor: 'accessing' stamp: 'mha 6/22/2007 19:42'!
targetMethod
	"Answer the currently cached CompiledMethod, i.e., the most recently looked-up one."
	
	^ self at: 2! !

!TFMonomorphicCache methodsFor: 'accessing' stamp: 'mha 6/21/2007 21:43'!
trips
	"Answer how many times the cached data have been replaced."
	
	^ self at: 5! !

Array variableSubclass: #TFPolymorphicCache
	instanceVariableNames: 'nextFreeEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TypeFeedback'!

!TFPolymorphicCache commentStamp: 'mha 6/18/2007 21:16' prior: 0!
An instance of this class represents a polymorphic cache, i.e., a send site-local cache that stores a given number of concrete target methods for the send in question. The class is a subclass of Array. Its instances are 1+(3*n) slots long, where n is the number of concrete receivers for the send.

At index 1, a polymorphic cache always contains the selector (a Symbol) denoting the message sent at this send site.

All subsequent indices are grouped in triples. Each triple contains, for the cache entry k, at the array index given below, the following data:

	k*3-1	:	the resolved target method (CompiledMethod)
	k*3		:	the concrete resolved target class (Class)
	k*3+1	:	the hotness counter for this particular cache entry (SmallInteger)

The order of concrete resolved method and class is reversed as compared to TFMonomorphicCache to allow for faster class lookup (one less arithmetic operation).

The hotness counter is maintained to allow for later optimisation (e.g., inlining). It is incremented each time the particular cache entry is hit.!

!TFPolymorphicCache class methodsFor: 'instance creation' stamp: 'mha 6/18/2007 21:00'!
defaultSize
	"Answer the number of entries that a newly created polymorphic cache should have."
	
	^ 4! !

!TFPolymorphicCache class methodsFor: 'instance creation' stamp: 'mha 6/21/2007 21:46'!
fromMonomorphicCache: monomorphicCache
	"Create a new polymorphic cache and initialise it with the data found in the monomorphic cache (a TFMonomorphicCache) passed as the argument. The argument's contents are placed in the first entry of the polymorphic cache. All other entries are left blank; they are to be filled subsequently by the virtual machine."
	
	^ (self new: self defaultSize * 3) "one cache entry consumes 3 slots"
		at: 1 put: monomorphicCache selector;
		at: 2 put: monomorphicCache targetClass;
		at: 3 put: monomorphicCache targetMethod;
		at: 4 put: monomorphicCache hotness;
		nextFreeEntry: 2;
		yourself! !

!TFPolymorphicCache class methodsFor: 'resetting' stamp: 'mha 6/21/2007 21:40'!
resetHotnessCounters
	"Reset all polymorphic caches' hotness counters to zero."
	
	self allInstancesDo: [ :pc | pc resetHotnessCounters ]! !

!TFPolymorphicCache methodsFor: 'private' stamp: 'mha 6/21/2007 21:44'!
classIndexForEntry: k
	"Answer the array index at which the cached class for cache entry k is stored."
	
	^ k * 3! !

!TFPolymorphicCache methodsFor: 'accessing' stamp: 'mha 6/21/2007 21:49'!
hotnessAt: k
	"Answer the hotness counter for this cache's k-th entry."
	
	^ self at: (self hotnessIndexForEntry: k)! !

!TFPolymorphicCache methodsFor: 'private' stamp: 'mha 6/21/2007 21:44'!
hotnessAt: k put: hotnessValue
	"Store the given hotness value in the hotness counter for cache entry k."
	
	self at: (self hotnessIndexForEntry: k) put: hotnessValue! !

!TFPolymorphicCache methodsFor: 'private' stamp: 'mha 6/21/2007 21:45'!
hotnessIndexForEntry: k
	"Answer the array index at which the hotness counter for cache entry k is stored."
	
	^ k * 3 + 1! !

!TFPolymorphicCache methodsFor: 'testing' stamp: 'mha 7/4/2007 01:26'!
isCache
	^ true! !

!TFPolymorphicCache methodsFor: 'testing' stamp: 'mha 7/4/2007 01:20'!
isPolymorphicCache
	^ true! !

!TFPolymorphicCache methodsFor: 'private' stamp: 'mha 6/21/2007 21:45'!
methodIndexForEntry: k
	"Answer the array index at which the cached method for cache entry k is stored."
	
	^ k * 3 - 1! !

!TFPolymorphicCache methodsFor: 'accessing' stamp: 'mha 6/21/2007 21:49'!
nextFreeEntry
	"Answer the number of the next free cache entry."
	
	^ nextFreeEntry! !

!TFPolymorphicCache methodsFor: 'private' stamp: 'mha 6/21/2007 21:45'!
nextFreeEntry: idx
	"Answer the next free cache entry number. Note that this is not the corresponding array index."
	
	nextFreeEntry := idx! !

!TFPolymorphicCache methodsFor: 'resetting' stamp: 'mha 6/21/2007 21:22'!
resetHotnessCounterAt: idx
	"Reset the hotness counters at cache entry idx to zero."
	
	self hotnessAt: idx put: 0! !

!TFPolymorphicCache methodsFor: 'resetting' stamp: 'mha 6/21/2007 21:47'!
resetHotnessCounters
	"Reset all of this cache's hotness counters to zero."
	
	1 to: self nextFreeEntry - 1 do: [ :i | self resetHotnessCounterAt: i ]! !

!TFPolymorphicCache methodsFor: 'accessing' stamp: 'mha 6/21/2007 21:47'!
selector
	"Answer the selector that is sent at this cache's send site."
	
	^ self at: 1! !

!TFPolymorphicCache methodsFor: 'private' stamp: 'mha 6/21/2007 21:48'!
selector: aSymbol
	"Store aSymbol as the selector sent at this cache's send site."
	
	self at: 1 put: aSymbol! !

!TFPolymorphicCache methodsFor: 'accessing' stamp: 'mha 6/21/2007 21:49'!
targetClassAt: k
	"Answer the cached class from this cache's k-th entry."
	
	^ self at: (self classIndexForEntry: k)! !

!TFPolymorphicCache methodsFor: 'accessing' stamp: 'mha 6/21/2007 21:50'!
targetMethodAt: k
	"Answer the cached CompiledMethod from this cache's k-th entry."
	
	^ self at: (self methodIndexForEntry: k)! !
